﻿
@{
    ViewBag.Title = "Page for API Client";
}

<h2>API client goes here</h2>

<script src="~/Scripts/react.production.min.js"></script>
<script src="~/Scripts/react-dom.production.min.js"></script>
<script src="~/Scripts/JSXTransformer.js"></script>


<div id="ReactApp"></div>

<script type="text/jsx">
    class App extends React.Component {
        constructor(props) {
            super(props);
            this.state = {
                id:0,
                code: "",
                departure: "",
                destination: "",
                airlines: "",
                items: [],
            }
        }

        onCodeChange(e) {
            this.setState({
                code: e.target.value,
            });
        }

        onDepartureChange(e) {
            this.setState({
                departure: e.target.value,
            });
        }

        onDestinationChange(e) {
            this.setState({
                destination: e.target.value,
            });
        }

        onAirlinesChange(e) {
            this.setState({
                airlines: e.target.value,
            });
        }

        onFlightsChange(e) {
            this.setState({
                id: e.target.value
            });
            fetch('/api/flights/' + e.target.value)
            .then(response => response.json())
            .then(
                data =>
                this.setState({
                    code: data.Code,
                    departure: data.Departure,
                    destination: data.Destination,
                    airlines: data.Airlines
                })
            )
        }

        addItem() {
            var self = this;
            var flight = {
                Code: self.state.code,
                Departure: self.state.departure,
                Destination: self.state.destination,
                Airlines: self.state.airlines
            };
            fetch('/api/flights', {
                method: 'post',
                body: JSON.stringify(flight),
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json'
                },
            }).then(function(response) {
                return response.json();
            }).then(function(data) {
                let items = self.state.items;
                items.push(data);
                self.setState({
                    items
                });
            });
            
        }

        editItem() {
            var self = this;
            var flight = {
                Id: self.state.id,
                Code: self.state.code,
                Departure: self.state.departure,
                Destination: self.state.destination,
                Airlines: self.state.airlines
            };
            fetch('/api/flights/' + self.state.id, {
                method: 'put',
                body: JSON.stringify(flight),
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json'
                },
            });
            
        }

        componentDidMount() {
            fetch('/api/flights')
            .then(response => response.json())
            .then(
                data =>
                this.setState({
                    items: data
                })
            )
        }

        listItems() {
            let items = this.state.items;
            return (
                <select onChange={(e) => this.onFlightsChange(e) }>
                    {
                        items.map((val, index) => {
                            return (
                                <option value={val.Id}>
                                    {val.Code}
                                </option>
                            );
                        })
                    }
                </select>
            );
        }

        render() {
            return (
                <div>
                    <input type="text" value={this.state.code} placeholder="Code" onChange={(e) => this.onCodeChange(e)} />
                    <br />
                    <input type="text" value={this.state.departure} placeholder="Departure" onChange={(e) => this.onDepartureChange(e)} />
                    <br />
                    <input type="text" value={this.state.destination} placeholder="Destination" onChange={(e) => this.onDestinationChange(e)} />
                    <br />
                    <input type="text" value={this.state.airlines} placeholder="Airlines" onChange={(e) => this.onAirlinesChange(e)} />
                    <br />
                    <button onClick={() => this.addItem()}>Add item</button>
                    <button onClick={() => this.editItem()}>Edit item</button>
                    <br />
                    {this.listItems()}
                </div>
            );
        }
    };

    ReactDOM.render(
    <App />,
    document.getElementById('ReactApp')
    );
</script>